Page MenuHomePhabricator

Enable WikiEditor by default in new installs of the MediaWiki bundle
Open, NormalPublic

Description

T30856 removes the 2006 wikitext editor from the MediaWiki Core. That would mean that users would get no toolbar at all without the WikiEditor extension. We propose that the WikiEditor extension be merged into the MediaWiki Core.

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptNov 10 2018, 6:16 PM
stjn added a subscriber: stjn.EditedNov 10 2018, 6:18 PM

Do you want ‘install it by default’, maybe? Merging a specific extension into core would just bring the same problems with regards to old toolbar.

IIRC, it already goes in standard MediaWiki bundle, but not sure if it’s installed with it.

As @stjn said, the WikiEditor extension is in the downloadable version of MediaWiki since 1.18, so I would say this is already done.

If you want to do is having it included in core I don't think it would be a good idea. To be honest, I rather have MediaWiki core without specific editors (only the text area) and have the possibility to install whatever editor I want just installing it as a extension. That's the simplest way to customize a wiki to the needs of most of the people.

Kghbln removed a subscriber: Kghbln.Nov 10 2018, 6:57 PM
Krenair added a subscriber: Krenair.

Yeah I don't know if it's necessary to merge it into the core repository. It's bundled already, people can disable it and get a plain text box if they want.

Aklapper renamed this task from Merge WikiEdtior into the MediaWiki Core to Merge WikiEditor into the MediaWiki Core.Nov 10 2018, 7:45 PM

Proposing to decline this task: Users would get no toolbar at all without the WikiEditor extension, but if users don't have the WikIEditor extension then it is because their administrators actively removed/disabled WikiEditor.

Krenair closed this task as Declined.Nov 10 2018, 8:00 PM

Proposing to decline this task: Users would get no toolbar at all without the WikiEditor extension, but if users don't have the WikIEditor extension then it is because their administrators actively removed/disabled WikiEditor.

Is that actually true? I think you still have to specifically enable it in the installer, and if you click fast install, the option is skipped.

I'd support having some of the bundled extensions (like this one) installed by default, where admins have to specifically unclick it, instead of opting out. (But I definitely do not support doing that for all extensions)

Legoktm reopened this task as Open.Nov 11 2018, 8:10 AM
Legoktm added a subscriber: Legoktm.

I think declining this is pretty premature. This has been proposed in other places like https://www.mediawiki.org/wiki/Suggestions_for_extensions_to_be_integrated#WikiEditor (no opposition, though no additional support either), and there have been comments like T30856#339558 suggesting it be moved into core as well.

More importantly, are there any legitimate arguments for MediaWiki to ship without a default enabled toolbar? Extensions are well, extensions. They should not implement what we consider to be core functionality.

I don't find arguments like T209217#4737133 convincing because customization is still possible, even if WikiEditor is in core.

Do you want ‘install it by default’, maybe? Merging a specific extension into core would just bring the same problems with regards to old toolbar.

What problems exactly? My understanding is that the "classic toolbar" was removed for maintenance reasons. Given that we have to maintain WikiEditor one way or another, where it lives is less consequential.

stjn added a comment.Nov 11 2018, 4:54 PM

What problems exactly? My understanding is that the "classic toolbar" was removed for maintenance reasons. Given that we have to maintain WikiEditor one way or another, where it lives is less consequential.

I was mainly thinking about over-reliance on one editor’s APIs that sprung up in multiple Wikimedia projects after removing classic edit toolbar from the core. I don’t really have an opinion about extension vs core and I’d support having WikiEditor enabled by default, but after tensions arising from Wikimedia projects using very old code that was attached to the specific editor, it seems strange to merge another editor into the core only to deprecate and remove its APIs once again after 2017 wikitext editor or 2020 voice command editor etc. come along.

More importantly, are there any legitimate arguments for MediaWiki to ship without a default enabled toolbar? Extensions are well, extensions. They should not implement what we consider to be core functionality.

The situation is very similar to skins. Actually, while you can use MediaWiki without any toolbar, you can't use it without any skin. And yet MediaWiki core comes without any skin, you have to install at least one (skin-) extension to get a functional wiki.
So obviously having vital components in extensions included in the default bundle instead of core has been working for years without any apparent problems, so why should it be problematic to do the same with the toolbar?

I also agree with stjn's previous comment: If you insist on having the "standard" toolbar to be included in core, sooner or later you will have to merge VisualEditor into core, or some other more advanced successor (though in my nor completely serious predictions from 5 years ago I scheduled the voice input editor only for 2026, not for 2020).

TheDJ added a subscriber: TheDJ.Nov 12 2018, 9:36 AM

@Schnark that is a well thought through argument.. thank you.

Proposing to decline this task: Users would get no toolbar at all without the WikiEditor extension, but if users don't have the WikIEditor extension then it is because their administrators actively removed/disabled WikiEditor.

Is that actually true? I think you still have to specifically enable it in the installer, and if you click fast install, the option is skipped.

I think this is the key question we need to answer. If the installer encourages you to do the right thing, as it does for skins, there shouldn't be a problem I guess ?

He7d3r added a subscriber: He7d3r.Nov 17 2018, 8:55 PM

Do you want ‘install it by default’, maybe? Merging a specific extension into core would just bring the same problems with regards to old toolbar.

What problems exactly? My understanding is that the "classic toolbar" was removed for maintenance reasons. Given that we have to maintain WikiEditor one way or another, where it lives is less consequential.

Lego, don't you think that the same lifecycle problems that affect the 2006WTE will also apply to – well, every single editing environment? Does anyone really think that WikiEditor will actually be used forever?

I think that "where it lives" has consequences for some MediaWiki users. IMO editing environments should be "plug and play". They should not be "core". You should pick out the ones that you want for your wikis, and not be required to install the ones that you don't want. As I was reminded today, there are third-party wikis that use MediaWiki, but that don't use WikiEditor (e.g., Shoutwiki). Is there any good reason to force them to install WikiEditor?

Also – I'm not actually going to say that you MediaWiki devs are anything less than perfect ;-) but at least some devs do seem to be human. If it's in core, then some humans may be tempted to write sloppy code that assumes that the editing environment will be there forever. Those "but it's in core, so I don't need to bother with..." bits were why it took so long to disentangle the 2006WTE from core. Let's not set ourselves up for that mess again.

TheDJ added a comment.EditedNov 27 2018, 1:34 PM

FYI, i checked and unlike skins, WikiEditor is not enabled by default:

FYI, unlike skins, WikiEditor is not enabled by default

Then it should probably be checked by default, but not merged into core.

We intentionally removed the toolbar from core with the plan to let core work by default as plainly as possible (basic, but functional). The idea of merging WikiEditor has come up in the past more than once, and as far as I know, nothing has changed since with regards to factors that led us to the decision to not merge. As such, I think we should re-affirm that here as well.

having said that, I very much agree that the usability of the web installer needs work. In particular with regards to bundled extensions being enabled by default.

I believe fixing this UI aspect from the web-based installer would solve the underlying use case for which @GeoffreyT2000 opened the task.

We could repurpose this task for that issue, or re-close and track separately.

TheDJ added a comment.Dec 18 2018, 1:06 PM

Making the installer support enabling certain bundled extensions by default would be T55983: Select checkboxes for bundled extensions by default I believe.

Happy to rename this to Please enable WikiEditor in new installs of MediaWiki by default and mark it as blocked by that if others agree.

Krinkle renamed this task from Merge WikiEditor into the MediaWiki Core to Enable WikiEditor by default in new installs of the MediaWiki bundle.Jan 2 2019, 8:32 PM
Krinkle triaged this task as Normal priority.

(Done.)

Krinkle moved this task from Inbox to Watching on the TechCom board.Jan 2 2019, 8:34 PM